<template>
    <teleport to="body">
        <transition name="fade">
            <div v-if="show">
                <div @click="close" class="absolute bg-black opacity-70 inset-0 z-0"></div>
                <div class="w-full max-w-lg p-3 relative mx-auto my-auto rounded-xl shadow-lg bg-white">
                    <div>
                        <div class="text-left py-2 px-3 flex-auto justify-center leading-6">
                            <div class="text-2xl font-bold py-2">
                                <slot name="header">DIALOG HEADER COMES HERE</slot>
                            </div>
                            <div class="px-1 text-md text-gray-500">
                                <slot>
                                    DIALOG CONTENT COMES HERE
                                </slot>
                            </div>
                        </div>
                        <div class="p-3 mt-2 text-right space-x-4 md:block">
                            <slot name="actions">BUTTONS COME HERE</slot>
                        </div>
                    </div>
                </div>
            </div>
        </transition>
    </teleport>
</template>

<script setup lang="ts">

interface BaseDialogProps {
    show: boolean;
    staticBackdrop: boolean;
}

const props = defineProps<BaseDialogProps>();

const emit = defineEmits(['close']);

function close() {
    if (!props.staticBackdrop) {
        emit('close');
    }
}

</script>

<style scoped>
.fade-enter-from,
.fade-leave-to {
    opacity: 0;
}

.fade-enter-active,
.fade-leave-active {
    transition: opacity 500ms ease-out;
}
</style>
